%voir fichier :roue_92
%format long
%Variables
digits (32);
Pi=3.1415926535897932384626433832795;
g=9.81;

%MODIFY THE VALUES BELOW ACCORDING TO OUR WHEEL DESIGN
Ma=1;%sliding weight mass ( for one weight)
Mb=14; %pendulum weight
Rw=0.5; %wheel radius
%Lp=1.9;%pendulum length (only the wire of the pendulum)
Rp=0.055;%pendulum weight radius
Rsil=0.031;%sliding weight radius
Lr=0.4;%distance from the center of the wheel where the pendulum is fixed
Pas=0.005;%calculation time step


clc;
close all;

Lp=(sqrt(2)/2)*Lr-Rp;

disp('Lp:');
disp(Lp);

RsilCondition=(Lr*(sqrt(2)-1)-Rp)/2;
if (Rsil > RsilCondition)
disp('Rsil does not respect the condition for non collision with the pendulum 2');
end

varLimits = [0 Pi/2;0 Pi/2];

syms AlphaC EpsC
S=vpasolve([Lr*cos(Pi/4-AlphaC) == (Lr-Rsil)*cos(AlphaC)+(Rp+Rsil)*cos(EpsC),(Lr-Rsil)*sin(AlphaC)+Lr*sin(Pi/4-AlphaC) == (Lp+Rp)+(Rp+Rsil)*sin(EpsC)],[AlphaC,EpsC],varLimits);


AlphaC=S.AlphaC;
angle_rad_AlphaC = S.AlphaC - 2*pi*floor( (S.AlphaC+pi)/(2*pi) );
angle_rad_EpsC = S.EpsC - 2*pi*floor( (S.EpsC+pi)/(2*pi) );
%verification first condition

disp('AlphaC in degrees:');
disp(radtodeg(angle_rad_AlphaC));

EpsFinal=asin((Lr*sin(Pi/4)-(Lp+Rp))/(Rp+Rsil));

disp('EpsFinal:');
disp(radtodeg(EpsFinal));

rfinal=Lr*cos(Pi/4)-(Rp+Rsil)*cos(EpsFinal)-Rsil;
disp('rfinal:');
disp(rfinal);



FinalValue=eval(angle_rad_AlphaC);

AlphaVector=0:Pas:FinalValue;

%Vector=FinalValue:Pas:0;
disp('Num elements:');
disp(numel(AlphaVector));

varLimits = [-Pi/2 Pi/2;0 Pi/2;0 Inf;0 Inf];

ResultAlphaVector=zeros(1,numel(AlphaVector));
ResultBetaVector=zeros(1,numel(AlphaVector));
ResultEpsVector=zeros(1,numel(AlphaVector));
ResultFVector=zeros(1,numel(AlphaVector));
ResultrVector=zeros(1,numel(AlphaVector));

for i=1:numel(AlphaVector)
Alpha=AlphaVector(i);

syms Eps Beta F r
S=vpasolve([Lr*cos(Pi/4-Alpha) + (Lp+Rp)*sin(Beta) == (r+Rsil)*cos(Alpha)+(Rp+Rsil)*cos(Eps),(r+Rsil)*sin(Alpha)+Lr*sin(Pi/4-Alpha) == (Lp+Rp)*cos(Beta)+(Rp+Rsil)*sin(Eps),F*cos(Eps+Alpha) == 2*Ma*g*sin(Alpha),F*cos(Eps-Beta) == Mb*g*sin(Beta)],[Eps,Beta,F,r],varLimits);

angle_rad_Eps = S.Eps - 2*pi*floor( (S.Eps+pi)/(2*pi) );
angle_rad_Beta = S.Beta - 2*pi*floor( (S.Beta+pi)/(2*pi) );
angle_rad_Alpha=Alpha-2*pi*floor( (Alpha+pi)/(2*pi) );

ResultAlphaVector(i)=angle_rad_Alpha;
ResultBetaVector(i)=angle_rad_Beta;
ResultEpsVector(i)=angle_rad_Eps;
ResultFVector(i)=eval(S.F);
ResultrVector(i)=eval(S.r);

DispVector= gallery('uniformdata',[1 5],0);
disp('  Alpha(rad) Beta(rad) Eps(rad)  F(N)      r(m)');
DispVector(1)=radtodeg(Alpha);
DispVector(2)=radtodeg(angle_rad_Beta);
DispVector(3)=radtodeg(S.Eps);
DispVector(4)=eval(S.F);
DispVector(5)=eval(S.r);

disp(DispVector);


end

ResultrVector=fliplr(ResultrVector);
ResultBetaVector=fliplr(ResultBetaVector);
ResultEpsVector=fliplr(ResultEpsVector);

roundval=round(AlphaC/Pas)*Pas;
AlphaC=roundval;
disp('AlphaC rounded:');
disp(AlphaC);

ThetaC=eval(Pi-AlphaC);

disp('ThetaC:');
disp(ThetaC);
%calculation of the total CG of the masses relative to the center of the
%wheel

ThetaAngle=0:Pas:2*Pi;
Xgp1=zeros(1,numel(ThetaAngle));
Xgp2=zeros(1,numel(ThetaAngle));
Xsli1=zeros(1,numel(ThetaAngle));
Xsli2=zeros(1,numel(ThetaAngle));
Xgtot=zeros(1,numel(ThetaAngle));
Xgpendulums=zeros(1,numel(ThetaAngle));

j=1;

%disp('AlphaVector:');
%disp(AlphaVector);
%disp('ThetaAngle:');
%disp(ThetaAngle);


for i=1:numel(AlphaVector)
    ResultrVector(i)=ResultrVector(i)-Rsil;
end

%disp(ResultrVector);

%disp(ResultrVector);
%CALCULATIONS OF THE CG abcisses OF THE SLIDING WEIGHT 1,2 and PENDULUM CG
for i=1:numel(ThetaAngle)
     if (0 <= ThetaAngle(i))
        if (ThetaAngle(i) < ThetaC) 
            Xgp1(i)=Lr*cos(ThetaAngle(i)+Pi/4);
            Xgp2(i)=Lr*cos(ThetaAngle(i)+Pi/4+Pi);
            Xsli1(i)=(Lr-Rsil)*cos(ThetaAngle(i));
            Xsli2(i)=(-Rsil)*cos(ThetaAngle(i));
        end
     end
     if (ThetaC <= ThetaAngle(i))
         if (ThetaAngle(i) <= Pi) 
            if (j <=numel(ResultrVector))
                Xgp1(i)=Lr*cos(ThetaAngle(i)+Pi/4)-(Lp+Rp)*sin(ResultBetaVector(j));
                Xgp2(i)=Lr*cos(ThetaAngle(i)+Pi/4+Pi);
                Xsli1(i)=(ResultrVector(j)+Rsil)*cos(ThetaAngle(i));
                Xsli2(i)=Xsli1(i)-(Lr+Rsil)*cos(ThetaAngle(i));
                j=j+1;
            end
        end
     end
     
     if (Pi < ThetaAngle(i))
      if (ThetaAngle(i) < (2*Pi-AlphaC))
        Xgp1(i)=Lr*cos(ThetaAngle(i)+Pi/4);
        Xgp2(i)=Lr*cos(ThetaAngle(i)+Pi/4+Pi);
        Xsli1(i)=(Rsil*cos(ThetaAngle(i)));
        Xsli2(i)=(-Lr+Rsil)*cos(ThetaAngle(i));
      end
     end  
end

j=1;

for i=1:numel(ThetaAngle)
  if (ThetaAngle(i) >= (2*Pi-AlphaC))
         Xgp1(i)=Lr*cos(ThetaAngle(i)+Pi/4);
         if (j <=numel(ResultrVector))  
             Xgp2(i)=Lr*cos(ThetaAngle(i)+Pi/4+Pi)-(Lp+Rp)*sin(ResultBetaVector(j));
             Xsli2(i)=(-ResultrVector(j)-Rsil)*cos(ThetaAngle(i));
             Xsli1(i)=(-ResultrVector(j)+Lr)*cos(ThetaAngle(i));
             j=j+1;
         end
  end
end



figure
plot(radtodeg(AlphaVector),radtodeg(ResultBetaVector));
title('Beta angle');
xlabel('Theta degrees');
ylabel('distance');


figure
plot(radtodeg(AlphaVector),ResultrVector);
title('r value');
xlabel('Theta degrees');
ylabel('distance');

figure
plot(radtodeg(AlphaVector),ResultEpsVector);
title('Eps value');
xlabel('Theta degrees');
ylabel('Eps');


figure
plot(radtodeg(ThetaAngle),Xgp1);
title('CG Xgp1');
xlabel('Theta degrees');
ylabel('distance');

figure
plot(radtodeg(ThetaAngle),Xgp2);
title('CG Xgp2');
xlabel('Theta degrees');
ylabel('distance');


figure
plot(radtodeg(ThetaAngle),Xsli1);
title('CG Xsli1');
xlabel('Alpha degrees');
ylabel('distance');

figure
plot(radtodeg(ThetaAngle),Xsli2);
title('CG Xsli2');
xlabel('Theta degrees');
ylabel('distance');

for i=1:numel(ThetaAngle)
    Xgtot(i)=(Mb*Xgp1(i)+Mb*Xgp2(i)+Ma*Xsli1(i)+Ma*Xsli2(i))/(2*Ma+2*Mb);
end

for i=1:numel(ThetaAngle)
    Xgpendulums(i)=(Mb*Xgp1(i)+Mb*Xgp2(i))/(2*Mb);
end


figure
plot(radtodeg(ThetaAngle),Xgtot);
title('CG Xgtot');
xlabel('Theta degrees');
ylabel('distance');


figure
plot(radtodeg(ThetaAngle),Xgpendulums);
title('CG only pendulums');
xlabel('Theta degrees');
ylabel('distance');

Q=cumtrapz(ThetaAngle,Xgtot);
ThirdQuadrant=Q(numel(ThetaAngle));
disp('Total:');
disp(ThirdQuadrant);

Couple=(2*Ma+Mb)*g*ThirdQuadrant;
disp('Mean Torque over a complete rotation of the system:');
disp(Couple);

Q=cumtrapz(ThetaAngle,Xgpendulums);
SubTotal=Q(numel(ThetaAngle));
disp('Total CG only pendulums:');
disp(SubTotal);

